import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AddonConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/addon#name Addon#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/addon#src Addon#src}
    */
    readonly src: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/addon pagerduty_addon}
*/
export declare class Addon extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/addon pagerduty_addon} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AddonConfig
    */
    constructor(scope: Construct, id: string, config: AddonConfig);
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _src?;
    get src(): string;
    set src(value: string);
    get srcInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
