import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyPriorityConfig extends cdktf.TerraformMetaArguments {
    /**
    * The name of the priority to find in the PagerDuty API
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/priority#name DataPagerdutyPriority#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/d/priority pagerduty_priority}
*/
export declare class DataPagerdutyPriority extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/d/priority pagerduty_priority} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyPriorityConfig
    */
    constructor(scope: Construct, id: string, config: DataPagerdutyPriorityConfig);
    get description(): string;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
