import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyRulesetConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/ruleset#name DataPagerdutyRuleset#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/d/ruleset pagerduty_ruleset}
*/
export declare class DataPagerdutyRuleset extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/d/ruleset pagerduty_ruleset} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyRulesetConfig
    */
    constructor(scope: Construct, id: string, config: DataPagerdutyRulesetConfig);
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get routingKeys(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
