import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyTeamConfig extends cdktf.TerraformMetaArguments {
    /**
    * The name of the team to find in the PagerDuty API
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/team#name DataPagerdutyTeam#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/team#parent DataPagerdutyTeam#parent}
    */
    readonly parent?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/d/team pagerduty_team}
*/
export declare class DataPagerdutyTeam extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/d/team pagerduty_team} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyTeamConfig
    */
    constructor(scope: Construct, id: string, config: DataPagerdutyTeamConfig);
    get description(): string;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _parent?;
    get parent(): string;
    set parent(value: string);
    resetParent(): void;
    get parentInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
