import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyUserConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/user#email DataPagerdutyUser#email}
    */
    readonly email: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/d/user pagerduty_user}
*/
export declare class DataPagerdutyUser extends cdktf.TerraformDataSource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/d/user pagerduty_user} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyUserConfig
    */
    constructor(scope: Construct, id: string, config: DataPagerdutyUserConfig);
    private _email?;
    get email(): string;
    set email(value: string);
    get emailInput(): string | undefined;
    get id(): string;
    get name(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
