import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface EscalationPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#description EscalationPolicy#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#name EscalationPolicy#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#num_loops EscalationPolicy#num_loops}
    */
    readonly numLoops?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#teams EscalationPolicy#teams}
    */
    readonly teams?: string[];
    /**
    * rule block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#rule EscalationPolicy#rule}
    */
    readonly rule: EscalationPolicyRule[] | cdktf.IResolvable;
}
export interface EscalationPolicyRuleTarget {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#id EscalationPolicy#id}
    */
    readonly id: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#type EscalationPolicy#type}
    */
    readonly type?: string;
}
export declare function escalationPolicyRuleTargetToTerraform(struct?: EscalationPolicyRuleTarget | cdktf.IResolvable): any;
export interface EscalationPolicyRule {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#escalation_delay_in_minutes EscalationPolicy#escalation_delay_in_minutes}
    */
    readonly escalationDelayInMinutes: number;
    /**
    * target block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy#target EscalationPolicy#target}
    */
    readonly target: EscalationPolicyRuleTarget[] | cdktf.IResolvable;
}
export declare function escalationPolicyRuleToTerraform(struct?: EscalationPolicyRule | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy pagerduty_escalation_policy}
*/
export declare class EscalationPolicy extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/escalation_policy pagerduty_escalation_policy} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options EscalationPolicyConfig
    */
    constructor(scope: Construct, id: string, config: EscalationPolicyConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _numLoops?;
    get numLoops(): number;
    set numLoops(value: number);
    resetNumLoops(): void;
    get numLoopsInput(): number | undefined;
    private _teams?;
    get teams(): string[];
    set teams(value: string[]);
    resetTeams(): void;
    get teamsInput(): string[] | undefined;
    private _rule?;
    get rule(): EscalationPolicyRule[] | cdktf.IResolvable;
    set rule(value: EscalationPolicyRule[] | cdktf.IResolvable);
    get ruleInput(): cdktf.IResolvable | EscalationPolicyRule[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
