import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface EventRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule#action_json EventRule#action_json}
    */
    readonly actionJson: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule#advanced_condition_json EventRule#advanced_condition_json}
    */
    readonly advancedConditionJson?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule#condition_json EventRule#condition_json}
    */
    readonly conditionJson: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule pagerduty_event_rule}
*/
export declare class EventRule extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/event_rule pagerduty_event_rule} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options EventRuleConfig
    */
    constructor(scope: Construct, id: string, config: EventRuleConfig);
    private _actionJson?;
    get actionJson(): string;
    set actionJson(value: string);
    get actionJsonInput(): string | undefined;
    private _advancedConditionJson?;
    get advancedConditionJson(): string;
    set advancedConditionJson(value: string);
    resetAdvancedConditionJson(): void;
    get advancedConditionJsonInput(): string | undefined;
    get catchAll(): cdktf.IResolvable;
    private _conditionJson?;
    get conditionJson(): string;
    set conditionJson(value: string);
    get conditionJsonInput(): string | undefined;
    get id(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
