import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ResponsePlayConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#conference_number ResponsePlay#conference_number}
    */
    readonly conferenceNumber?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#conference_url ResponsePlay#conference_url}
    */
    readonly conferenceUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#description ResponsePlay#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#from ResponsePlay#from}
    */
    readonly from: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#name ResponsePlay#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#responders_message ResponsePlay#responders_message}
    */
    readonly respondersMessage?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#runnability ResponsePlay#runnability}
    */
    readonly runnability?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#subscribers_message ResponsePlay#subscribers_message}
    */
    readonly subscribersMessage?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#team ResponsePlay#team}
    */
    readonly team?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#type ResponsePlay#type}
    */
    readonly type?: string;
    /**
    * responder block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#responder ResponsePlay#responder}
    */
    readonly responder?: ResponsePlayResponder[] | cdktf.IResolvable;
    /**
    * subscriber block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#subscriber ResponsePlay#subscriber}
    */
    readonly subscriber?: ResponsePlaySubscriber[] | cdktf.IResolvable;
}
export declare class ResponsePlayResponderEscalationRuleTarget extends cdktf.ComplexComputedList {
    get id(): string;
    get type(): string;
}
export declare class ResponsePlayResponderEscalationRule extends cdktf.ComplexComputedList {
    get escalationDelayInMinutes(): number;
    get id(): string;
    get target(): cdktf.IResolvable;
}
export declare class ResponsePlayResponderService extends cdktf.ComplexComputedList {
    get id(): string;
    get type(): string;
}
export declare class ResponsePlayResponderTeam extends cdktf.ComplexComputedList {
    get id(): string;
    get type(): string;
}
export interface ResponsePlayResponder {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#description ResponsePlay#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#id ResponsePlay#id}
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#name ResponsePlay#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#type ResponsePlay#type}
    */
    readonly type?: string;
}
export declare function responsePlayResponderToTerraform(struct?: ResponsePlayResponder | cdktf.IResolvable): any;
export interface ResponsePlaySubscriber {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#id ResponsePlay#id}
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play#type ResponsePlay#type}
    */
    readonly type?: string;
}
export declare function responsePlaySubscriberToTerraform(struct?: ResponsePlaySubscriber | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play pagerduty_response_play}
*/
export declare class ResponsePlay extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/response_play pagerduty_response_play} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ResponsePlayConfig
    */
    constructor(scope: Construct, id: string, config: ResponsePlayConfig);
    private _conferenceNumber?;
    get conferenceNumber(): string;
    set conferenceNumber(value: string);
    resetConferenceNumber(): void;
    get conferenceNumberInput(): string | undefined;
    private _conferenceUrl?;
    get conferenceUrl(): string;
    set conferenceUrl(value: string);
    resetConferenceUrl(): void;
    get conferenceUrlInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _from?;
    get from(): string;
    set from(value: string);
    get fromInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _respondersMessage?;
    get respondersMessage(): string;
    set respondersMessage(value: string);
    resetRespondersMessage(): void;
    get respondersMessageInput(): string | undefined;
    private _runnability?;
    get runnability(): string;
    set runnability(value: string);
    resetRunnability(): void;
    get runnabilityInput(): string | undefined;
    private _subscribersMessage?;
    get subscribersMessage(): string;
    set subscribersMessage(value: string);
    resetSubscribersMessage(): void;
    get subscribersMessageInput(): string | undefined;
    private _team?;
    get team(): string;
    set team(value: string);
    resetTeam(): void;
    get teamInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _responder?;
    get responder(): ResponsePlayResponder[] | cdktf.IResolvable;
    set responder(value: ResponsePlayResponder[] | cdktf.IResolvable);
    resetResponder(): void;
    get responderInput(): cdktf.IResolvable | ResponsePlayResponder[] | undefined;
    private _subscriber?;
    get subscriber(): ResponsePlaySubscriber[] | cdktf.IResolvable;
    set subscriber(value: ResponsePlaySubscriber[] | cdktf.IResolvable);
    resetSubscriber(): void;
    get subscriberInput(): cdktf.IResolvable | ResponsePlaySubscriber[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
