import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface RulesetRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#disabled RulesetRule#disabled}
    */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#position RulesetRule#position}
    */
    readonly position?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#ruleset RulesetRule#ruleset}
    */
    readonly ruleset: string;
    /**
    * actions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#actions RulesetRule#actions}
    */
    readonly actions?: RulesetRuleActions;
    /**
    * conditions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#conditions RulesetRule#conditions}
    */
    readonly conditions?: RulesetRuleConditions;
    /**
    * time_frame block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#time_frame RulesetRule#time_frame}
    */
    readonly timeFrame?: RulesetRuleTimeFrame;
    /**
    * variable block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#variable RulesetRule#variable}
    */
    readonly variable?: RulesetRuleVariable[] | cdktf.IResolvable;
}
export interface RulesetRuleActionsAnnotate {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: string;
}
export declare function rulesetRuleActionsAnnotateToTerraform(struct?: RulesetRuleActionsAnnotate | cdktf.IResolvable): any;
export interface RulesetRuleActionsEventAction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: string;
}
export declare function rulesetRuleActionsEventActionToTerraform(struct?: RulesetRuleActionsEventAction | cdktf.IResolvable): any;
export interface RulesetRuleActionsExtractions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#regex RulesetRule#regex}
    */
    readonly regex?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#source RulesetRule#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#target RulesetRule#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#template RulesetRule#template}
    */
    readonly template?: string;
}
export declare function rulesetRuleActionsExtractionsToTerraform(struct?: RulesetRuleActionsExtractions | cdktf.IResolvable): any;
export interface RulesetRuleActionsPriority {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: string;
}
export declare function rulesetRuleActionsPriorityToTerraform(struct?: RulesetRuleActionsPriority | cdktf.IResolvable): any;
export interface RulesetRuleActionsRoute {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: string;
}
export declare function rulesetRuleActionsRouteToTerraform(struct?: RulesetRuleActionsRoute | cdktf.IResolvable): any;
export interface RulesetRuleActionsSeverity {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: string;
}
export declare function rulesetRuleActionsSeverityToTerraform(struct?: RulesetRuleActionsSeverity | cdktf.IResolvable): any;
export interface RulesetRuleActionsSuppress {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#threshold_time_amount RulesetRule#threshold_time_amount}
    */
    readonly thresholdTimeAmount?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#threshold_time_unit RulesetRule#threshold_time_unit}
    */
    readonly thresholdTimeUnit?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#threshold_value RulesetRule#threshold_value}
    */
    readonly thresholdValue?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: boolean | cdktf.IResolvable;
}
export declare function rulesetRuleActionsSuppressToTerraform(struct?: RulesetRuleActionsSuppress | cdktf.IResolvable): any;
export interface RulesetRuleActionsSuspend {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: number;
}
export declare function rulesetRuleActionsSuspendToTerraform(struct?: RulesetRuleActionsSuspend | cdktf.IResolvable): any;
export interface RulesetRuleActions {
    /**
    * annotate block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#annotate RulesetRule#annotate}
    */
    readonly annotate?: RulesetRuleActionsAnnotate[] | cdktf.IResolvable;
    /**
    * event_action block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#event_action RulesetRule#event_action}
    */
    readonly eventAction?: RulesetRuleActionsEventAction[] | cdktf.IResolvable;
    /**
    * extractions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#extractions RulesetRule#extractions}
    */
    readonly extractions?: RulesetRuleActionsExtractions[] | cdktf.IResolvable;
    /**
    * priority block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#priority RulesetRule#priority}
    */
    readonly priority?: RulesetRuleActionsPriority[] | cdktf.IResolvable;
    /**
    * route block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#route RulesetRule#route}
    */
    readonly route?: RulesetRuleActionsRoute[] | cdktf.IResolvable;
    /**
    * severity block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#severity RulesetRule#severity}
    */
    readonly severity?: RulesetRuleActionsSeverity[] | cdktf.IResolvable;
    /**
    * suppress block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#suppress RulesetRule#suppress}
    */
    readonly suppress?: RulesetRuleActionsSuppress[] | cdktf.IResolvable;
    /**
    * suspend block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#suspend RulesetRule#suspend}
    */
    readonly suspend?: RulesetRuleActionsSuspend[] | cdktf.IResolvable;
}
export declare function rulesetRuleActionsToTerraform(struct?: RulesetRuleActionsOutputReference | RulesetRuleActions): any;
export declare class RulesetRuleActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): RulesetRuleActions | undefined;
    set internalValue(value: RulesetRuleActions | undefined);
    private _annotate?;
    get annotate(): RulesetRuleActionsAnnotate[] | cdktf.IResolvable;
    set annotate(value: RulesetRuleActionsAnnotate[] | cdktf.IResolvable);
    resetAnnotate(): void;
    get annotateInput(): cdktf.IResolvable | RulesetRuleActionsAnnotate[] | undefined;
    private _eventAction?;
    get eventAction(): RulesetRuleActionsEventAction[] | cdktf.IResolvable;
    set eventAction(value: RulesetRuleActionsEventAction[] | cdktf.IResolvable);
    resetEventAction(): void;
    get eventActionInput(): cdktf.IResolvable | RulesetRuleActionsEventAction[] | undefined;
    private _extractions?;
    get extractions(): RulesetRuleActionsExtractions[] | cdktf.IResolvable;
    set extractions(value: RulesetRuleActionsExtractions[] | cdktf.IResolvable);
    resetExtractions(): void;
    get extractionsInput(): cdktf.IResolvable | RulesetRuleActionsExtractions[] | undefined;
    private _priority?;
    get priority(): RulesetRuleActionsPriority[] | cdktf.IResolvable;
    set priority(value: RulesetRuleActionsPriority[] | cdktf.IResolvable);
    resetPriority(): void;
    get priorityInput(): cdktf.IResolvable | RulesetRuleActionsPriority[] | undefined;
    private _route?;
    get route(): RulesetRuleActionsRoute[] | cdktf.IResolvable;
    set route(value: RulesetRuleActionsRoute[] | cdktf.IResolvable);
    resetRoute(): void;
    get routeInput(): cdktf.IResolvable | RulesetRuleActionsRoute[] | undefined;
    private _severity?;
    get severity(): RulesetRuleActionsSeverity[] | cdktf.IResolvable;
    set severity(value: RulesetRuleActionsSeverity[] | cdktf.IResolvable);
    resetSeverity(): void;
    get severityInput(): cdktf.IResolvable | RulesetRuleActionsSeverity[] | undefined;
    private _suppress?;
    get suppress(): RulesetRuleActionsSuppress[] | cdktf.IResolvable;
    set suppress(value: RulesetRuleActionsSuppress[] | cdktf.IResolvable);
    resetSuppress(): void;
    get suppressInput(): cdktf.IResolvable | RulesetRuleActionsSuppress[] | undefined;
    private _suspend?;
    get suspend(): RulesetRuleActionsSuspend[] | cdktf.IResolvable;
    set suspend(value: RulesetRuleActionsSuspend[] | cdktf.IResolvable);
    resetSuspend(): void;
    get suspendInput(): cdktf.IResolvable | RulesetRuleActionsSuspend[] | undefined;
}
export interface RulesetRuleConditionsSubconditionsParameter {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#path RulesetRule#path}
    */
    readonly path?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: string;
}
export declare function rulesetRuleConditionsSubconditionsParameterToTerraform(struct?: RulesetRuleConditionsSubconditionsParameter | cdktf.IResolvable): any;
export interface RulesetRuleConditionsSubconditions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#operator RulesetRule#operator}
    */
    readonly operator?: string;
    /**
    * parameter block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#parameter RulesetRule#parameter}
    */
    readonly parameter?: RulesetRuleConditionsSubconditionsParameter[] | cdktf.IResolvable;
}
export declare function rulesetRuleConditionsSubconditionsToTerraform(struct?: RulesetRuleConditionsSubconditions | cdktf.IResolvable): any;
export interface RulesetRuleConditions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#operator RulesetRule#operator}
    */
    readonly operator?: string;
    /**
    * subconditions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#subconditions RulesetRule#subconditions}
    */
    readonly subconditions?: RulesetRuleConditionsSubconditions[] | cdktf.IResolvable;
}
export declare function rulesetRuleConditionsToTerraform(struct?: RulesetRuleConditionsOutputReference | RulesetRuleConditions): any;
export declare class RulesetRuleConditionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): RulesetRuleConditions | undefined;
    set internalValue(value: RulesetRuleConditions | undefined);
    private _operator?;
    get operator(): string;
    set operator(value: string);
    resetOperator(): void;
    get operatorInput(): string | undefined;
    private _subconditions?;
    get subconditions(): RulesetRuleConditionsSubconditions[] | cdktf.IResolvable;
    set subconditions(value: RulesetRuleConditionsSubconditions[] | cdktf.IResolvable);
    resetSubconditions(): void;
    get subconditionsInput(): cdktf.IResolvable | RulesetRuleConditionsSubconditions[] | undefined;
}
export interface RulesetRuleTimeFrameActiveBetween {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#end_time RulesetRule#end_time}
    */
    readonly endTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#start_time RulesetRule#start_time}
    */
    readonly startTime?: number;
}
export declare function rulesetRuleTimeFrameActiveBetweenToTerraform(struct?: RulesetRuleTimeFrameActiveBetween | cdktf.IResolvable): any;
export interface RulesetRuleTimeFrameScheduledWeekly {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#duration RulesetRule#duration}
    */
    readonly duration?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#start_time RulesetRule#start_time}
    */
    readonly startTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#timezone RulesetRule#timezone}
    */
    readonly timezone?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#weekdays RulesetRule#weekdays}
    */
    readonly weekdays?: number[];
}
export declare function rulesetRuleTimeFrameScheduledWeeklyToTerraform(struct?: RulesetRuleTimeFrameScheduledWeekly | cdktf.IResolvable): any;
export interface RulesetRuleTimeFrame {
    /**
    * active_between block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#active_between RulesetRule#active_between}
    */
    readonly activeBetween?: RulesetRuleTimeFrameActiveBetween[] | cdktf.IResolvable;
    /**
    * scheduled_weekly block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#scheduled_weekly RulesetRule#scheduled_weekly}
    */
    readonly scheduledWeekly?: RulesetRuleTimeFrameScheduledWeekly[] | cdktf.IResolvable;
}
export declare function rulesetRuleTimeFrameToTerraform(struct?: RulesetRuleTimeFrameOutputReference | RulesetRuleTimeFrame): any;
export declare class RulesetRuleTimeFrameOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): RulesetRuleTimeFrame | undefined;
    set internalValue(value: RulesetRuleTimeFrame | undefined);
    private _activeBetween?;
    get activeBetween(): RulesetRuleTimeFrameActiveBetween[] | cdktf.IResolvable;
    set activeBetween(value: RulesetRuleTimeFrameActiveBetween[] | cdktf.IResolvable);
    resetActiveBetween(): void;
    get activeBetweenInput(): cdktf.IResolvable | RulesetRuleTimeFrameActiveBetween[] | undefined;
    private _scheduledWeekly?;
    get scheduledWeekly(): RulesetRuleTimeFrameScheduledWeekly[] | cdktf.IResolvable;
    set scheduledWeekly(value: RulesetRuleTimeFrameScheduledWeekly[] | cdktf.IResolvable);
    resetScheduledWeekly(): void;
    get scheduledWeeklyInput(): cdktf.IResolvable | RulesetRuleTimeFrameScheduledWeekly[] | undefined;
}
export interface RulesetRuleVariableParameters {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#path RulesetRule#path}
    */
    readonly path?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#value RulesetRule#value}
    */
    readonly value?: string;
}
export declare function rulesetRuleVariableParametersToTerraform(struct?: RulesetRuleVariableParameters | cdktf.IResolvable): any;
export interface RulesetRuleVariable {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#name RulesetRule#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#type RulesetRule#type}
    */
    readonly type?: string;
    /**
    * parameters block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule#parameters RulesetRule#parameters}
    */
    readonly parameters?: RulesetRuleVariableParameters[] | cdktf.IResolvable;
}
export declare function rulesetRuleVariableToTerraform(struct?: RulesetRuleVariable | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule pagerduty_ruleset_rule}
*/
export declare class RulesetRule extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset_rule pagerduty_ruleset_rule} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options RulesetRuleConfig
    */
    constructor(scope: Construct, id: string, config: RulesetRuleConfig);
    private _disabled?;
    get disabled(): boolean | cdktf.IResolvable;
    set disabled(value: boolean | cdktf.IResolvable);
    resetDisabled(): void;
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    get id(): string;
    private _position?;
    get position(): number;
    set position(value: number);
    resetPosition(): void;
    get positionInput(): number | undefined;
    private _ruleset?;
    get ruleset(): string;
    set ruleset(value: string);
    get rulesetInput(): string | undefined;
    private _actions;
    get actions(): RulesetRuleActionsOutputReference;
    putActions(value: RulesetRuleActions): void;
    resetActions(): void;
    get actionsInput(): RulesetRuleActions | undefined;
    private _conditions;
    get conditions(): RulesetRuleConditionsOutputReference;
    putConditions(value: RulesetRuleConditions): void;
    resetConditions(): void;
    get conditionsInput(): RulesetRuleConditions | undefined;
    private _timeFrame;
    get timeFrame(): RulesetRuleTimeFrameOutputReference;
    putTimeFrame(value: RulesetRuleTimeFrame): void;
    resetTimeFrame(): void;
    get timeFrameInput(): RulesetRuleTimeFrame | undefined;
    private _variable?;
    get variable(): RulesetRuleVariable[] | cdktf.IResolvable;
    set variable(value: RulesetRuleVariable[] | cdktf.IResolvable);
    resetVariable(): void;
    get variableInput(): cdktf.IResolvable | RulesetRuleVariable[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
