import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ScheduleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#description Schedule#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#name Schedule#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#overflow Schedule#overflow}
    */
    readonly overflow?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#teams Schedule#teams}
    */
    readonly teams?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#time_zone Schedule#time_zone}
    */
    readonly timeZone: string;
    /**
    * layer block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#layer Schedule#layer}
    */
    readonly layer: ScheduleLayer[] | cdktf.IResolvable;
}
export interface ScheduleLayerRestriction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#duration_seconds Schedule#duration_seconds}
    */
    readonly durationSeconds: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#start_day_of_week Schedule#start_day_of_week}
    */
    readonly startDayOfWeek?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#start_time_of_day Schedule#start_time_of_day}
    */
    readonly startTimeOfDay: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#type Schedule#type}
    */
    readonly type: string;
}
export declare function scheduleLayerRestrictionToTerraform(struct?: ScheduleLayerRestriction | cdktf.IResolvable): any;
export interface ScheduleLayer {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#end Schedule#end}
    */
    readonly end?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#name Schedule#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#rotation_turn_length_seconds Schedule#rotation_turn_length_seconds}
    */
    readonly rotationTurnLengthSeconds: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#rotation_virtual_start Schedule#rotation_virtual_start}
    */
    readonly rotationVirtualStart: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#start Schedule#start}
    */
    readonly start: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#users Schedule#users}
    */
    readonly users: string[];
    /**
    * restriction block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule#restriction Schedule#restriction}
    */
    readonly restriction?: ScheduleLayerRestriction[] | cdktf.IResolvable;
}
export declare function scheduleLayerToTerraform(struct?: ScheduleLayer | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule pagerduty_schedule}
*/
export declare class Schedule extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/schedule pagerduty_schedule} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ScheduleConfig
    */
    constructor(scope: Construct, id: string, config: ScheduleConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _overflow?;
    get overflow(): boolean | cdktf.IResolvable;
    set overflow(value: boolean | cdktf.IResolvable);
    resetOverflow(): void;
    get overflowInput(): boolean | cdktf.IResolvable | undefined;
    private _teams?;
    get teams(): string[];
    set teams(value: string[]);
    resetTeams(): void;
    get teamsInput(): string[] | undefined;
    private _timeZone?;
    get timeZone(): string;
    set timeZone(value: string);
    get timeZoneInput(): string | undefined;
    private _layer?;
    get layer(): ScheduleLayer[] | cdktf.IResolvable;
    set layer(value: ScheduleLayer[] | cdktf.IResolvable);
    get layerInput(): cdktf.IResolvable | ScheduleLayer[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
