import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ServiceDependencyConfig extends cdktf.TerraformMetaArguments {
    /**
    * dependency block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency#dependency ServiceDependency#dependency}
    */
    readonly dependency: ServiceDependencyDependency[] | cdktf.IResolvable;
}
export interface ServiceDependencyDependencyDependentService {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency#id ServiceDependency#id}
    */
    readonly id: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency#type ServiceDependency#type}
    */
    readonly type: string;
}
export declare function serviceDependencyDependencyDependentServiceToTerraform(struct?: ServiceDependencyDependencyDependentService | cdktf.IResolvable): any;
export interface ServiceDependencyDependencySupportingService {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency#id ServiceDependency#id}
    */
    readonly id: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency#type ServiceDependency#type}
    */
    readonly type: string;
}
export declare function serviceDependencyDependencySupportingServiceToTerraform(struct?: ServiceDependencyDependencySupportingService | cdktf.IResolvable): any;
export interface ServiceDependencyDependency {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency#type ServiceDependency#type}
    */
    readonly type?: string;
    /**
    * dependent_service block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency#dependent_service ServiceDependency#dependent_service}
    */
    readonly dependentService: ServiceDependencyDependencyDependentService[] | cdktf.IResolvable;
    /**
    * supporting_service block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency#supporting_service ServiceDependency#supporting_service}
    */
    readonly supportingService: ServiceDependencyDependencySupportingService[] | cdktf.IResolvable;
}
export declare function serviceDependencyDependencyToTerraform(struct?: ServiceDependencyDependency | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency pagerduty_service_dependency}
*/
export declare class ServiceDependency extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/service_dependency pagerduty_service_dependency} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ServiceDependencyConfig
    */
    constructor(scope: Construct, id: string, config: ServiceDependencyConfig);
    get id(): string;
    private _dependency?;
    get dependency(): ServiceDependencyDependency[] | cdktf.IResolvable;
    set dependency(value: ServiceDependencyDependency[] | cdktf.IResolvable);
    get dependencyInput(): cdktf.IResolvable | ServiceDependencyDependency[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
