import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ServiceEventRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#disabled ServiceEventRule#disabled}
    */
    readonly disabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#position ServiceEventRule#position}
    */
    readonly position?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#service ServiceEventRule#service}
    */
    readonly service: string;
    /**
    * actions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#actions ServiceEventRule#actions}
    */
    readonly actions?: ServiceEventRuleActions;
    /**
    * conditions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#conditions ServiceEventRule#conditions}
    */
    readonly conditions?: ServiceEventRuleConditions;
    /**
    * time_frame block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#time_frame ServiceEventRule#time_frame}
    */
    readonly timeFrame?: ServiceEventRuleTimeFrame;
    /**
    * variable block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#variable ServiceEventRule#variable}
    */
    readonly variable?: ServiceEventRuleVariable[] | cdktf.IResolvable;
}
export interface ServiceEventRuleActionsAnnotate {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#value ServiceEventRule#value}
    */
    readonly value?: string;
}
export declare function serviceEventRuleActionsAnnotateToTerraform(struct?: ServiceEventRuleActionsAnnotate | cdktf.IResolvable): any;
export interface ServiceEventRuleActionsEventAction {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#value ServiceEventRule#value}
    */
    readonly value?: string;
}
export declare function serviceEventRuleActionsEventActionToTerraform(struct?: ServiceEventRuleActionsEventAction | cdktf.IResolvable): any;
export interface ServiceEventRuleActionsExtractions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#regex ServiceEventRule#regex}
    */
    readonly regex?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#source ServiceEventRule#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#target ServiceEventRule#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#template ServiceEventRule#template}
    */
    readonly template?: string;
}
export declare function serviceEventRuleActionsExtractionsToTerraform(struct?: ServiceEventRuleActionsExtractions | cdktf.IResolvable): any;
export interface ServiceEventRuleActionsPriority {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#value ServiceEventRule#value}
    */
    readonly value?: string;
}
export declare function serviceEventRuleActionsPriorityToTerraform(struct?: ServiceEventRuleActionsPriority | cdktf.IResolvable): any;
export interface ServiceEventRuleActionsSeverity {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#value ServiceEventRule#value}
    */
    readonly value?: string;
}
export declare function serviceEventRuleActionsSeverityToTerraform(struct?: ServiceEventRuleActionsSeverity | cdktf.IResolvable): any;
export interface ServiceEventRuleActionsSuppress {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#threshold_time_amount ServiceEventRule#threshold_time_amount}
    */
    readonly thresholdTimeAmount?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#threshold_time_unit ServiceEventRule#threshold_time_unit}
    */
    readonly thresholdTimeUnit?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#threshold_value ServiceEventRule#threshold_value}
    */
    readonly thresholdValue?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#value ServiceEventRule#value}
    */
    readonly value?: boolean | cdktf.IResolvable;
}
export declare function serviceEventRuleActionsSuppressToTerraform(struct?: ServiceEventRuleActionsSuppress | cdktf.IResolvable): any;
export interface ServiceEventRuleActionsSuspend {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#value ServiceEventRule#value}
    */
    readonly value?: number;
}
export declare function serviceEventRuleActionsSuspendToTerraform(struct?: ServiceEventRuleActionsSuspend | cdktf.IResolvable): any;
export interface ServiceEventRuleActions {
    /**
    * annotate block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#annotate ServiceEventRule#annotate}
    */
    readonly annotate?: ServiceEventRuleActionsAnnotate[] | cdktf.IResolvable;
    /**
    * event_action block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#event_action ServiceEventRule#event_action}
    */
    readonly eventAction?: ServiceEventRuleActionsEventAction[] | cdktf.IResolvable;
    /**
    * extractions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#extractions ServiceEventRule#extractions}
    */
    readonly extractions?: ServiceEventRuleActionsExtractions[] | cdktf.IResolvable;
    /**
    * priority block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#priority ServiceEventRule#priority}
    */
    readonly priority?: ServiceEventRuleActionsPriority[] | cdktf.IResolvable;
    /**
    * severity block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#severity ServiceEventRule#severity}
    */
    readonly severity?: ServiceEventRuleActionsSeverity[] | cdktf.IResolvable;
    /**
    * suppress block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#suppress ServiceEventRule#suppress}
    */
    readonly suppress?: ServiceEventRuleActionsSuppress[] | cdktf.IResolvable;
    /**
    * suspend block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#suspend ServiceEventRule#suspend}
    */
    readonly suspend?: ServiceEventRuleActionsSuspend[] | cdktf.IResolvable;
}
export declare function serviceEventRuleActionsToTerraform(struct?: ServiceEventRuleActionsOutputReference | ServiceEventRuleActions): any;
export declare class ServiceEventRuleActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceEventRuleActions | undefined;
    set internalValue(value: ServiceEventRuleActions | undefined);
    private _annotate?;
    get annotate(): ServiceEventRuleActionsAnnotate[] | cdktf.IResolvable;
    set annotate(value: ServiceEventRuleActionsAnnotate[] | cdktf.IResolvable);
    resetAnnotate(): void;
    get annotateInput(): cdktf.IResolvable | ServiceEventRuleActionsAnnotate[] | undefined;
    private _eventAction?;
    get eventAction(): ServiceEventRuleActionsEventAction[] | cdktf.IResolvable;
    set eventAction(value: ServiceEventRuleActionsEventAction[] | cdktf.IResolvable);
    resetEventAction(): void;
    get eventActionInput(): cdktf.IResolvable | ServiceEventRuleActionsEventAction[] | undefined;
    private _extractions?;
    get extractions(): ServiceEventRuleActionsExtractions[] | cdktf.IResolvable;
    set extractions(value: ServiceEventRuleActionsExtractions[] | cdktf.IResolvable);
    resetExtractions(): void;
    get extractionsInput(): cdktf.IResolvable | ServiceEventRuleActionsExtractions[] | undefined;
    private _priority?;
    get priority(): ServiceEventRuleActionsPriority[] | cdktf.IResolvable;
    set priority(value: ServiceEventRuleActionsPriority[] | cdktf.IResolvable);
    resetPriority(): void;
    get priorityInput(): cdktf.IResolvable | ServiceEventRuleActionsPriority[] | undefined;
    private _severity?;
    get severity(): ServiceEventRuleActionsSeverity[] | cdktf.IResolvable;
    set severity(value: ServiceEventRuleActionsSeverity[] | cdktf.IResolvable);
    resetSeverity(): void;
    get severityInput(): cdktf.IResolvable | ServiceEventRuleActionsSeverity[] | undefined;
    private _suppress?;
    get suppress(): ServiceEventRuleActionsSuppress[] | cdktf.IResolvable;
    set suppress(value: ServiceEventRuleActionsSuppress[] | cdktf.IResolvable);
    resetSuppress(): void;
    get suppressInput(): cdktf.IResolvable | ServiceEventRuleActionsSuppress[] | undefined;
    private _suspend?;
    get suspend(): ServiceEventRuleActionsSuspend[] | cdktf.IResolvable;
    set suspend(value: ServiceEventRuleActionsSuspend[] | cdktf.IResolvable);
    resetSuspend(): void;
    get suspendInput(): cdktf.IResolvable | ServiceEventRuleActionsSuspend[] | undefined;
}
export interface ServiceEventRuleConditionsSubconditionsParameter {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#path ServiceEventRule#path}
    */
    readonly path?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#value ServiceEventRule#value}
    */
    readonly value?: string;
}
export declare function serviceEventRuleConditionsSubconditionsParameterToTerraform(struct?: ServiceEventRuleConditionsSubconditionsParameter | cdktf.IResolvable): any;
export interface ServiceEventRuleConditionsSubconditions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#operator ServiceEventRule#operator}
    */
    readonly operator?: string;
    /**
    * parameter block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#parameter ServiceEventRule#parameter}
    */
    readonly parameter?: ServiceEventRuleConditionsSubconditionsParameter[] | cdktf.IResolvable;
}
export declare function serviceEventRuleConditionsSubconditionsToTerraform(struct?: ServiceEventRuleConditionsSubconditions | cdktf.IResolvable): any;
export interface ServiceEventRuleConditions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#operator ServiceEventRule#operator}
    */
    readonly operator?: string;
    /**
    * subconditions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#subconditions ServiceEventRule#subconditions}
    */
    readonly subconditions?: ServiceEventRuleConditionsSubconditions[] | cdktf.IResolvable;
}
export declare function serviceEventRuleConditionsToTerraform(struct?: ServiceEventRuleConditionsOutputReference | ServiceEventRuleConditions): any;
export declare class ServiceEventRuleConditionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceEventRuleConditions | undefined;
    set internalValue(value: ServiceEventRuleConditions | undefined);
    private _operator?;
    get operator(): string;
    set operator(value: string);
    resetOperator(): void;
    get operatorInput(): string | undefined;
    private _subconditions?;
    get subconditions(): ServiceEventRuleConditionsSubconditions[] | cdktf.IResolvable;
    set subconditions(value: ServiceEventRuleConditionsSubconditions[] | cdktf.IResolvable);
    resetSubconditions(): void;
    get subconditionsInput(): cdktf.IResolvable | ServiceEventRuleConditionsSubconditions[] | undefined;
}
export interface ServiceEventRuleTimeFrameActiveBetween {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#end_time ServiceEventRule#end_time}
    */
    readonly endTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#start_time ServiceEventRule#start_time}
    */
    readonly startTime?: number;
}
export declare function serviceEventRuleTimeFrameActiveBetweenToTerraform(struct?: ServiceEventRuleTimeFrameActiveBetween | cdktf.IResolvable): any;
export interface ServiceEventRuleTimeFrameScheduledWeekly {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#duration ServiceEventRule#duration}
    */
    readonly duration?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#start_time ServiceEventRule#start_time}
    */
    readonly startTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#timezone ServiceEventRule#timezone}
    */
    readonly timezone?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#weekdays ServiceEventRule#weekdays}
    */
    readonly weekdays?: number[];
}
export declare function serviceEventRuleTimeFrameScheduledWeeklyToTerraform(struct?: ServiceEventRuleTimeFrameScheduledWeekly | cdktf.IResolvable): any;
export interface ServiceEventRuleTimeFrame {
    /**
    * active_between block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#active_between ServiceEventRule#active_between}
    */
    readonly activeBetween?: ServiceEventRuleTimeFrameActiveBetween[] | cdktf.IResolvable;
    /**
    * scheduled_weekly block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#scheduled_weekly ServiceEventRule#scheduled_weekly}
    */
    readonly scheduledWeekly?: ServiceEventRuleTimeFrameScheduledWeekly[] | cdktf.IResolvable;
}
export declare function serviceEventRuleTimeFrameToTerraform(struct?: ServiceEventRuleTimeFrameOutputReference | ServiceEventRuleTimeFrame): any;
export declare class ServiceEventRuleTimeFrameOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceEventRuleTimeFrame | undefined;
    set internalValue(value: ServiceEventRuleTimeFrame | undefined);
    private _activeBetween?;
    get activeBetween(): ServiceEventRuleTimeFrameActiveBetween[] | cdktf.IResolvable;
    set activeBetween(value: ServiceEventRuleTimeFrameActiveBetween[] | cdktf.IResolvable);
    resetActiveBetween(): void;
    get activeBetweenInput(): cdktf.IResolvable | ServiceEventRuleTimeFrameActiveBetween[] | undefined;
    private _scheduledWeekly?;
    get scheduledWeekly(): ServiceEventRuleTimeFrameScheduledWeekly[] | cdktf.IResolvable;
    set scheduledWeekly(value: ServiceEventRuleTimeFrameScheduledWeekly[] | cdktf.IResolvable);
    resetScheduledWeekly(): void;
    get scheduledWeeklyInput(): cdktf.IResolvable | ServiceEventRuleTimeFrameScheduledWeekly[] | undefined;
}
export interface ServiceEventRuleVariableParameters {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#path ServiceEventRule#path}
    */
    readonly path?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#value ServiceEventRule#value}
    */
    readonly value?: string;
}
export declare function serviceEventRuleVariableParametersToTerraform(struct?: ServiceEventRuleVariableParameters | cdktf.IResolvable): any;
export interface ServiceEventRuleVariable {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#name ServiceEventRule#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#type ServiceEventRule#type}
    */
    readonly type?: string;
    /**
    * parameters block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule#parameters ServiceEventRule#parameters}
    */
    readonly parameters?: ServiceEventRuleVariableParameters[] | cdktf.IResolvable;
}
export declare function serviceEventRuleVariableToTerraform(struct?: ServiceEventRuleVariable | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule pagerduty_service_event_rule}
*/
export declare class ServiceEventRule extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/service_event_rule pagerduty_service_event_rule} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ServiceEventRuleConfig
    */
    constructor(scope: Construct, id: string, config: ServiceEventRuleConfig);
    private _disabled?;
    get disabled(): boolean | cdktf.IResolvable;
    set disabled(value: boolean | cdktf.IResolvable);
    resetDisabled(): void;
    get disabledInput(): boolean | cdktf.IResolvable | undefined;
    get id(): string;
    private _position?;
    get position(): number;
    set position(value: number);
    resetPosition(): void;
    get positionInput(): number | undefined;
    private _service?;
    get service(): string;
    set service(value: string);
    get serviceInput(): string | undefined;
    private _actions;
    get actions(): ServiceEventRuleActionsOutputReference;
    putActions(value: ServiceEventRuleActions): void;
    resetActions(): void;
    get actionsInput(): ServiceEventRuleActions | undefined;
    private _conditions;
    get conditions(): ServiceEventRuleConditionsOutputReference;
    putConditions(value: ServiceEventRuleConditions): void;
    resetConditions(): void;
    get conditionsInput(): ServiceEventRuleConditions | undefined;
    private _timeFrame;
    get timeFrame(): ServiceEventRuleTimeFrameOutputReference;
    putTimeFrame(value: ServiceEventRuleTimeFrame): void;
    resetTimeFrame(): void;
    get timeFrameInput(): ServiceEventRuleTimeFrame | undefined;
    private _variable?;
    get variable(): ServiceEventRuleVariable[] | cdktf.IResolvable;
    set variable(value: ServiceEventRuleVariable[] | cdktf.IResolvable);
    resetVariable(): void;
    get variableInput(): cdktf.IResolvable | ServiceEventRuleVariable[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
