import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ServiceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#acknowledgement_timeout Service#acknowledgement_timeout}
    */
    readonly acknowledgementTimeout?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#alert_creation Service#alert_creation}
    */
    readonly alertCreation?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#alert_grouping Service#alert_grouping}
    */
    readonly alertGrouping?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#alert_grouping_timeout Service#alert_grouping_timeout}
    */
    readonly alertGroupingTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#auto_resolve_timeout Service#auto_resolve_timeout}
    */
    readonly autoResolveTimeout?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#description Service#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#escalation_policy Service#escalation_policy}
    */
    readonly escalationPolicy: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#name Service#name}
    */
    readonly name: string;
    /**
    * alert_grouping_parameters block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#alert_grouping_parameters Service#alert_grouping_parameters}
    */
    readonly alertGroupingParameters?: ServiceAlertGroupingParameters;
    /**
    * incident_urgency_rule block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#incident_urgency_rule Service#incident_urgency_rule}
    */
    readonly incidentUrgencyRule?: ServiceIncidentUrgencyRule;
    /**
    * scheduled_actions block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#scheduled_actions Service#scheduled_actions}
    */
    readonly scheduledActions?: ServiceScheduledActions[] | cdktf.IResolvable;
    /**
    * support_hours block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#support_hours Service#support_hours}
    */
    readonly supportHours?: ServiceSupportHours;
}
export interface ServiceAlertGroupingParametersConfig {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#aggregate Service#aggregate}
    */
    readonly aggregate?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#fields Service#fields}
    */
    readonly fields?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#timeout Service#timeout}
    */
    readonly timeout?: number;
}
export declare function serviceAlertGroupingParametersConfigToTerraform(struct?: ServiceAlertGroupingParametersConfigOutputReference | ServiceAlertGroupingParametersConfig): any;
export declare class ServiceAlertGroupingParametersConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceAlertGroupingParametersConfig | undefined;
    set internalValue(value: ServiceAlertGroupingParametersConfig | undefined);
    private _aggregate?;
    get aggregate(): string;
    set aggregate(value: string);
    resetAggregate(): void;
    get aggregateInput(): string | undefined;
    private _fields?;
    get fields(): string[];
    set fields(value: string[]);
    resetFields(): void;
    get fieldsInput(): string[] | undefined;
    private _timeout?;
    get timeout(): number;
    set timeout(value: number);
    resetTimeout(): void;
    get timeoutInput(): number | undefined;
}
export interface ServiceAlertGroupingParameters {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#type Service#type}
    */
    readonly type?: string;
    /**
    * config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#config Service#config}
    */
    readonly config?: ServiceAlertGroupingParametersConfig;
}
export declare function serviceAlertGroupingParametersToTerraform(struct?: ServiceAlertGroupingParametersOutputReference | ServiceAlertGroupingParameters): any;
export declare class ServiceAlertGroupingParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceAlertGroupingParameters | undefined;
    set internalValue(value: ServiceAlertGroupingParameters | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _config;
    get config(): ServiceAlertGroupingParametersConfigOutputReference;
    putConfig(value: ServiceAlertGroupingParametersConfig): void;
    resetConfig(): void;
    get configInput(): ServiceAlertGroupingParametersConfig | undefined;
}
export interface ServiceIncidentUrgencyRuleDuringSupportHours {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#type Service#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#urgency Service#urgency}
    */
    readonly urgency?: string;
}
export declare function serviceIncidentUrgencyRuleDuringSupportHoursToTerraform(struct?: ServiceIncidentUrgencyRuleDuringSupportHoursOutputReference | ServiceIncidentUrgencyRuleDuringSupportHours): any;
export declare class ServiceIncidentUrgencyRuleDuringSupportHoursOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceIncidentUrgencyRuleDuringSupportHours | undefined;
    set internalValue(value: ServiceIncidentUrgencyRuleDuringSupportHours | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _urgency?;
    get urgency(): string;
    set urgency(value: string);
    resetUrgency(): void;
    get urgencyInput(): string | undefined;
}
export interface ServiceIncidentUrgencyRuleOutsideSupportHours {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#type Service#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#urgency Service#urgency}
    */
    readonly urgency?: string;
}
export declare function serviceIncidentUrgencyRuleOutsideSupportHoursToTerraform(struct?: ServiceIncidentUrgencyRuleOutsideSupportHoursOutputReference | ServiceIncidentUrgencyRuleOutsideSupportHours): any;
export declare class ServiceIncidentUrgencyRuleOutsideSupportHoursOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceIncidentUrgencyRuleOutsideSupportHours | undefined;
    set internalValue(value: ServiceIncidentUrgencyRuleOutsideSupportHours | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _urgency?;
    get urgency(): string;
    set urgency(value: string);
    resetUrgency(): void;
    get urgencyInput(): string | undefined;
}
export interface ServiceIncidentUrgencyRule {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#type Service#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#urgency Service#urgency}
    */
    readonly urgency?: string;
    /**
    * during_support_hours block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#during_support_hours Service#during_support_hours}
    */
    readonly duringSupportHours?: ServiceIncidentUrgencyRuleDuringSupportHours;
    /**
    * outside_support_hours block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#outside_support_hours Service#outside_support_hours}
    */
    readonly outsideSupportHours?: ServiceIncidentUrgencyRuleOutsideSupportHours;
}
export declare function serviceIncidentUrgencyRuleToTerraform(struct?: ServiceIncidentUrgencyRuleOutputReference | ServiceIncidentUrgencyRule): any;
export declare class ServiceIncidentUrgencyRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceIncidentUrgencyRule | undefined;
    set internalValue(value: ServiceIncidentUrgencyRule | undefined);
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _urgency?;
    get urgency(): string;
    set urgency(value: string);
    resetUrgency(): void;
    get urgencyInput(): string | undefined;
    private _duringSupportHours;
    get duringSupportHours(): ServiceIncidentUrgencyRuleDuringSupportHoursOutputReference;
    putDuringSupportHours(value: ServiceIncidentUrgencyRuleDuringSupportHours): void;
    resetDuringSupportHours(): void;
    get duringSupportHoursInput(): ServiceIncidentUrgencyRuleDuringSupportHours | undefined;
    private _outsideSupportHours;
    get outsideSupportHours(): ServiceIncidentUrgencyRuleOutsideSupportHoursOutputReference;
    putOutsideSupportHours(value: ServiceIncidentUrgencyRuleOutsideSupportHours): void;
    resetOutsideSupportHours(): void;
    get outsideSupportHoursInput(): ServiceIncidentUrgencyRuleOutsideSupportHours | undefined;
}
export interface ServiceScheduledActionsAt {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#name Service#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#type Service#type}
    */
    readonly type?: string;
}
export declare function serviceScheduledActionsAtToTerraform(struct?: ServiceScheduledActionsAt | cdktf.IResolvable): any;
export interface ServiceScheduledActions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#to_urgency Service#to_urgency}
    */
    readonly toUrgency?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#type Service#type}
    */
    readonly type?: string;
    /**
    * at block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#at Service#at}
    */
    readonly at?: ServiceScheduledActionsAt[] | cdktf.IResolvable;
}
export declare function serviceScheduledActionsToTerraform(struct?: ServiceScheduledActions | cdktf.IResolvable): any;
export interface ServiceSupportHours {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#days_of_week Service#days_of_week}
    */
    readonly daysOfWeek?: number[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#end_time Service#end_time}
    */
    readonly endTime?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#start_time Service#start_time}
    */
    readonly startTime?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#time_zone Service#time_zone}
    */
    readonly timeZone?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service#type Service#type}
    */
    readonly type?: string;
}
export declare function serviceSupportHoursToTerraform(struct?: ServiceSupportHoursOutputReference | ServiceSupportHours): any;
export declare class ServiceSupportHoursOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param isSingleItem True if this is a block, false if it's a list
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    get internalValue(): ServiceSupportHours | undefined;
    set internalValue(value: ServiceSupportHours | undefined);
    private _daysOfWeek?;
    get daysOfWeek(): number[];
    set daysOfWeek(value: number[]);
    resetDaysOfWeek(): void;
    get daysOfWeekInput(): number[] | undefined;
    private _endTime?;
    get endTime(): string;
    set endTime(value: string);
    resetEndTime(): void;
    get endTimeInput(): string | undefined;
    private _startTime?;
    get startTime(): string;
    set startTime(value: string);
    resetStartTime(): void;
    get startTimeInput(): string | undefined;
    private _timeZone?;
    get timeZone(): string;
    set timeZone(value: string);
    resetTimeZone(): void;
    get timeZoneInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/service pagerduty_service}
*/
export declare class Service extends cdktf.TerraformResource {
    static readonly tfResourceType: string;
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/service pagerduty_service} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ServiceConfig
    */
    constructor(scope: Construct, id: string, config: ServiceConfig);
    private _acknowledgementTimeout?;
    get acknowledgementTimeout(): string;
    set acknowledgementTimeout(value: string);
    resetAcknowledgementTimeout(): void;
    get acknowledgementTimeoutInput(): string | undefined;
    private _alertCreation?;
    get alertCreation(): string;
    set alertCreation(value: string);
    resetAlertCreation(): void;
    get alertCreationInput(): string | undefined;
    private _alertGrouping?;
    get alertGrouping(): string;
    set alertGrouping(value: string);
    resetAlertGrouping(): void;
    get alertGroupingInput(): string | undefined;
    private _alertGroupingTimeout?;
    get alertGroupingTimeout(): number;
    set alertGroupingTimeout(value: number);
    resetAlertGroupingTimeout(): void;
    get alertGroupingTimeoutInput(): number | undefined;
    private _autoResolveTimeout?;
    get autoResolveTimeout(): string;
    set autoResolveTimeout(value: string);
    resetAutoResolveTimeout(): void;
    get autoResolveTimeoutInput(): string | undefined;
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _escalationPolicy?;
    get escalationPolicy(): string;
    set escalationPolicy(value: string);
    get escalationPolicyInput(): string | undefined;
    get htmlUrl(): string;
    get id(): string;
    get lastIncidentTimestamp(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get status(): string;
    private _alertGroupingParameters;
    get alertGroupingParameters(): ServiceAlertGroupingParametersOutputReference;
    putAlertGroupingParameters(value: ServiceAlertGroupingParameters): void;
    resetAlertGroupingParameters(): void;
    get alertGroupingParametersInput(): ServiceAlertGroupingParameters | undefined;
    private _incidentUrgencyRule;
    get incidentUrgencyRule(): ServiceIncidentUrgencyRuleOutputReference;
    putIncidentUrgencyRule(value: ServiceIncidentUrgencyRule): void;
    resetIncidentUrgencyRule(): void;
    get incidentUrgencyRuleInput(): ServiceIncidentUrgencyRule | undefined;
    private _scheduledActions?;
    get scheduledActions(): ServiceScheduledActions[] | cdktf.IResolvable;
    set scheduledActions(value: ServiceScheduledActions[] | cdktf.IResolvable);
    resetScheduledActions(): void;
    get scheduledActionsInput(): cdktf.IResolvable | ServiceScheduledActions[] | undefined;
    private _supportHours;
    get supportHours(): ServiceSupportHoursOutputReference;
    putSupportHours(value: ServiceSupportHours): void;
    resetSupportHours(): void;
    get supportHoursInput(): ServiceSupportHours | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
